#ifndef _XDRBUF_INCLUDED

#include <stdlib.h>
#ifdef WIN32
    #include <windows.h>
#else
    typedef char * HGLOBAL;
#endif

#define _XDRBUF_INCLUDED

class XDR_BUFFER {

    public:
        
#if defined(_RPCDC) && defined(WIN32)
    __declspec(dllexport)
#endif
        void autoinit ();

#if defined(_RPCDC) && defined(WIN32)
    __declspec(dllexport)
#endif
        XDR_BUFFER ();

#if defined(_RPCDC) && defined(WIN32)
    __declspec(dllexport)
#endif
        void autodelete ();

#if defined(_RPCDC) && defined(WIN32)
    __declspec(dllexport)
#endif
        ~XDR_BUFFER ();

        void Lock (size_t buflen);
        void Free ();
        
        size_t bufsize;
        int lock;
        char *buffer;  
        HGLOBAL hbuffer;
};

#endif
